#include <iostream>

const int FieldRows = 4;
const int FieldCols = 4;

enum SpotState { Free, X, O };

void printField( SpotState *field )
{
    for (int y=0; y<FieldRows; y++) {
        for (int x=0; x<FieldCols; x++) {
            std::cout << " ";
            switch (field[y*FieldCols+x]) {
            case SpotState::Free:
                std::cout << "[ ]";
                break;
            case SpotState::X:
                std::cout << "[X]";
                break;
            case SpotState::O:
                std::cout << "[O]";
                break;
            }
        }
        std::cout << std::endl;
    }
    std::cout << std::endl;
}

int evaluateField( SpotState *field )
{
    return 0;
}

int main()
{
    SpotState *field = new SpotState[FieldRows*FieldCols];
    bool running = true;
    bool X = true;
    while(running) {
        // Print field
        printField( field );
        std::cout << "Player " << (X ? 1 : 2) << "'s turn" << std::endl;

        // TODO: Get player input

        // TODO: Check ranges

        // TODO: Check if spot is unset

        // TODO: Mark spot

        // Check for winner
        if (int winner = evaluateField(field) > 0) {
            std::cout << "Player " << winner << " won!" << std::endl;
            break;
        }
        X = !X;
    }
    delete[] field;
    return 0;
}
